Unit AFG2R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFG2R(var A :Array of Real; var S :Array of Integer;
                N :Integer);

implementation

procedure AFG2R(var A :Array of Real; var S :Array of Integer;
                N :Integer);
var
F,BH,BI,BP,J,I,L :Integer;
BK,BO,BX,CC,CD,PR,TK :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4,_5,_6,_7,_8;
begin
if ( N = 1 ) 
 then goto _8;
F := 0;
_1:
F := F+1;
BK := ZERO;
for J:=F to N do
 begin
  BP := F;
  BO := ZERO;
  for I:=F to N do
   begin
    BX := Abs(A[(I-1)+(J-1)*N]);
    if ( BO >= BX ) 
     then goto _2;
    BO := BX;
    BP := I;
_2:
   end;
  if ( BK > BO ) 
   then goto _3;
  BK := BO;
  BH := BP;
  BI := J;
_3:
 end;
for I:=1 to N do
 begin
  CC := A[(I-1)+(BI-1)*N];
  A[(I-1)+(BI-1)*N] := A[(I-1)+(F-1)*N];
_4:
  A[(I-1)+(F-1)*N] := CC;
 end;
for J:=1 to N do
 begin
  CD := A[(BH-1)+(J-1)*N];
  A[(BH-1)+(J-1)*N] := A[(F-1)+(J-1)*N];
_5:
  A[(F-1)+(J-1)*N] := CD;
 end;
S[(F-1)+0*N] := BH;
S[(F-1)+1*N] := BI;
TK := Abs(A[(F-1)+(F-1)*N]);
if ( TK = 0.0 ) 
 then goto _8;
PR := 1.0/A[(F-1)+(F-1)*N];
L := F+1;
for I:=L to N do
 begin
_6:
  A[(I-1)+(F-1)*N] := PR*A[(I-1)+(F-1)*N];
 end;
for J:=L to N do
 begin
  for I:=L to N do
   begin
_7:
    A[(I-1)+(J-1)*N] := A[(I-1)+(J-1)*N]-A[(F-1)+(J-1)*N]*A[(I-1)+(F-1)*N];
   end;
 end;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _8
       else goto _8;
_8:
end;

end.
